diff --git a/drivers/net/nfp/meson.build b/drivers/net/nfp/meson.build
index ab64d0cac3..810f02ae5b 100644
--- a/drivers/net/nfp/meson.build
+++ b/drivers/net/nfp/meson.build
@@ -18,7 +18,7 @@ sources = files(
         'nfpcore/nfp_mutex.c',
         'nfpcore/nfp_nsp_eth.c',
         'nfpcore/nfp_hwinfo.c',
-        'nfp_net.c',
+        'nfp_common.c',
         'nfp_rxtx.c',
         'nfp_cpp_bridge.c',
         'nfp_ethdev_vf.c',
diff --git a/drivers/net/nfp/nfp_net.c b/drivers/net/nfp/nfp_common.c
similarity index 99%
rename from drivers/net/nfp/nfp_net.c
rename to drivers/net/nfp/nfp_common.c
index a6097eaab0..87e8f5f333 100644
--- a/drivers/net/nfp/nfp_net.c
+++ b/drivers/net/nfp/nfp_common.c
@@ -8,9 +8,9 @@
 /*
  * vim:shiftwidth=8:noexpandtab
  *
- * @file dpdk/pmd/nfp_net.c
+ * @file dpdk/pmd/nfp_common.c
  *
- * Netronome vNIC DPDK Poll-Mode Driver: Main entry point
+ * Netronome vNIC DPDK Poll-Mode Driver: Common files
  */
 
 #include <rte_byteorder.h>
diff --git a/drivers/net/nfp/nfp_net_pmd.h b/drivers/net/nfp/nfp_common.h
similarity index 99%
rename from drivers/net/nfp/nfp_net_pmd.h
rename to drivers/net/nfp/nfp_common.h
index dc05e888df..54ac937bd2 100644
--- a/drivers/net/nfp/nfp_net_pmd.h
+++ b/drivers/net/nfp/nfp_common.h
@@ -11,8 +11,8 @@
  * Netronome NFP_NET PMD driver
  */
 
-#ifndef _NFP_NET_PMD_H_
-#define _NFP_NET_PMD_H_
+#ifndef _NFP_COMMON_H_
+#define _NFP_COMMON_H_
 
 #define NFP_NET_PMD_VERSION "0.1"
 #define PCI_VENDOR_ID_NETRONOME         0x19ee
@@ -404,7 +404,7 @@ int nfp_net_rss_config_default(struct rte_eth_dev *dev);
 #define NFP_NET_DEV_PRIVATE_TO_PF(dev_priv)\
 	(((struct nfp_net_hw *)dev_priv)->pf_dev)
 
-#endif /* _NFP_NET_PMD_H_ */
+#endif /* _NFP_COMMON_H_ */
 /*
  * Local variables:
  * c-file-style: "Linux"
diff --git a/drivers/net/nfp/nfp_cpp_bridge.c b/drivers/net/nfp/nfp_cpp_bridge.c
index d916793338..74a0eacb3f 100644
--- a/drivers/net/nfp/nfp_cpp_bridge.c
+++ b/drivers/net/nfp/nfp_cpp_bridge.c
@@ -19,7 +19,7 @@
 #include "nfpcore/nfp_mip.h"
 #include "nfpcore/nfp_nsp.h"
 
-#include "nfp_net_logs.h"
+#include "nfp_logs.h"
 #include "nfp_cpp_bridge.h"
 
 #include <sys/ioctl.h>
diff --git a/drivers/net/nfp/nfp_net_ctrl.h b/drivers/net/nfp/nfp_ctrl.h
similarity index 99%
rename from drivers/net/nfp/nfp_net_ctrl.h
rename to drivers/net/nfp/nfp_ctrl.h
index 4f26ccf483..4dd62ef194 100644
--- a/drivers/net/nfp/nfp_net_ctrl.h
+++ b/drivers/net/nfp/nfp_ctrl.h
@@ -8,8 +8,8 @@
  *
  * Netronome network device driver: Control BAR layout
  */
-#ifndef _NFP_NET_CTRL_H_
-#define _NFP_NET_CTRL_H_
+#ifndef _NFP_CTRL_H_
+#define _NFP_CTRL_H_
 
 /*
  * Configuration BAR size.
@@ -317,7 +317,7 @@
 /* PF multiport offset */
 #define NFP_PF_CSR_SLICE_SIZE	(32 * 1024)
 
-#endif /* _NFP_NET_CTRL_H_ */
+#endif /* _NFP_CTRL_H_ */
 /*
  * Local variables:
  * c-file-style: "Linux"
diff --git a/drivers/net/nfp/nfp_ethdev.c b/drivers/net/nfp/nfp_ethdev.c
index ab08906704..29e6bb128a 100644
--- a/drivers/net/nfp/nfp_ethdev.c
+++ b/drivers/net/nfp/nfp_ethdev.c
@@ -30,10 +30,10 @@
 #include "nfpcore/nfp_rtsym.h"
 #include "nfpcore/nfp_nsp.h"
 
-#include "nfp_net_pmd.h"
+#include "nfp_common.h"
 #include "nfp_rxtx.h"
-#include "nfp_net_logs.h"
-#include "nfp_net_ctrl.h"
+#include "nfp_logs.h"
+#include "nfp_ctrl.h"
 #include "nfp_cpp_bridge.h"
 
 
diff --git a/drivers/net/nfp/nfp_ethdev_vf.c b/drivers/net/nfp/nfp_ethdev_vf.c
index 223142c0ed..b697b55865 100644
--- a/drivers/net/nfp/nfp_ethdev_vf.c
+++ b/drivers/net/nfp/nfp_ethdev_vf.c
@@ -16,10 +16,10 @@
 #include "nfpcore/nfp_mip.h"
 #include "nfpcore/nfp_rtsym.h"
 
-#include "nfp_net_pmd.h"
+#include "nfp_common.h"
 #include "nfp_rxtx.h"
-#include "nfp_net_logs.h"
-#include "nfp_net_ctrl.h"
+#include "nfp_logs.h"
+#include "nfp_ctrl.h"
 
 static void nfp_netvf_read_mac(struct nfp_net_hw *hw);
 static int nfp_netvf_start(struct rte_eth_dev *dev);
diff --git a/drivers/net/nfp/nfp_net_logs.h b/drivers/net/nfp/nfp_logs.h
similarity index 94%
rename from drivers/net/nfp/nfp_net_logs.h
rename to drivers/net/nfp/nfp_logs.h
index 27dd87611b..bd5a5e1ec5 100644
--- a/drivers/net/nfp/nfp_net_logs.h
+++ b/drivers/net/nfp/nfp_logs.h
@@ -3,8 +3,8 @@
  * All rights reserved.
  */
 
-#ifndef _NFP_NET_LOGS_H_
-#define _NFP_NET_LOGS_H_
+#ifndef _NFP_LOGS_H_
+#define _NFP_LOGS_H_
 
 #include <rte_log.h>
 
@@ -44,4 +44,4 @@ extern int nfp_logtype_driver;
 	rte_log(RTE_LOG_ ## level, nfp_logtype_driver, \
 		"%s(): " fmt "\n", __func__, ## args)
 
-#endif /* _NFP_NET_LOGS_H_ */
+#endif /* _NFP_LOGS_H_ */
diff --git a/drivers/net/nfp/nfp_rxtx.c b/drivers/net/nfp/nfp_rxtx.c
index 9ee9e5c9a3..1402c5f84a 100644
--- a/drivers/net/nfp/nfp_rxtx.c
+++ b/drivers/net/nfp/nfp_rxtx.c
@@ -16,10 +16,10 @@
 #include <ethdev_driver.h>
 #include <ethdev_pci.h>
 
-#include "nfp_net_pmd.h"
+#include "nfp_common.h"
 #include "nfp_rxtx.h"
-#include "nfp_net_logs.h"
-#include "nfp_net_ctrl.h"
+#include "nfp_logs.h"
+#include "nfp_ctrl.h"
 
 /* Prototypes */
 static int nfp_net_rx_fill_freelist(struct nfp_net_rxq *rxq);